--[[
Interface: 1.5.1.0 b6732

Copyright (C) GtX (Andy), 2019

Author: GtX | Andy
Date: 05.10.2019

Contact:
https://forum.giants-software.com
https://github.com/GtX-Andy

History:
V 1.0.0.0 @ 05.10.2019 - Release Version

Important:
Free for use in other mods - no permission needed.
No changes are to be made to this script without permission from GtX | Andy

Frei verwendbar - keine erlaubnis nötig
An diesem Skript dürfen ohne Genehmigung von GtX | Andy keine Änderungen vorgenommen werden
]]


PressureWasherVehicleStateEvent = {}

local PressureWasherVehicleStateEvent_mt = Class(PressureWasherVehicleStateEvent, Event)
InitEventClass(PressureWasherVehicleStateEvent, "PressureWasherVehicleStateEvent")

function PressureWasherVehicleStateEvent:emptyNew()
    local self = Event:new(PressureWasherVehicleStateEvent_mt)
    return self
end

function PressureWasherVehicleStateEvent:new(vehicle, state, player)
    local self = PressureWasherVehicleStateEvent:emptyNew()

    self.vehicle = vehicle
    self.state = state
    self.player = player

    return self
end

function PressureWasherVehicleStateEvent:readStream(streamId, connection)
    self.vehicle = NetworkUtil.readNodeObject(streamId)
    self.state = streamReadUIntN(streamId, 3)

    if self.state == PressureWasherVehicle.STATE_ACTIVE then
        self.player = NetworkUtil.readNodeObject(streamId)
    end

    self:run(connection)
end

function PressureWasherVehicleStateEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.vehicle)
    streamWriteUIntN(streamId, self.state, 3)

    if self.state == PressureWasherVehicle.STATE_ACTIVE then
        NetworkUtil.writeNodeObject(streamId, self.player)
    end
end

function PressureWasherVehicleStateEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.vehicle)
    end

    self.vehicle:setPressureWasherState(self.state, self.player, true)
end

function PressureWasherVehicleStateEvent.sendEvent(vehicle, state, player, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(PressureWasherVehicleStateEvent:new(vehicle, state, player), nil, nil, vehicle)
        else
            g_client:getServerConnection():sendEvent(PressureWasherVehicleStateEvent:new(vehicle, state, player))
        end
    end
end
